#include "descriptor/descriptor.h"

int main(void) {

	//VARIABILI//////////////////////////////////////////////////////////////////////////////////

	ITEM Luce01,Luce02;
	ITEM legno,carta,metallo,intonaco,plastica,rosso;
	ITEM metallo2,giallo,nero,nerogomma,plastica2,parquet,grigio,bianco;
	ITEM parete_ant,parete_dx,parete_post,parete_sx,pavimento,quadro,superficie_quadro,stanza;
	ITEM scrivania,piano_scrivania,gamba01,gamba02,gamba03,gamba04;
	ITEM lampada;
	ITEM pedana;
	ITEM cassettone,cassettone01,cassettone02;
	ITEM ruote,alaAnteriore,airscope,cockpit,musetto;
	ITEM retrotreno,fondopiatto,piegaAirscope,cerchioni,preseAria;
	ITEM sospensioniAnt,sospensioniPos;
	ITEM supportoAla,alaPosteriore,alaPost01,alaPost02,alaPost03;
	ITEM motore,motore01,motore02,motore03,motore04;
	ITEM muso,muso01,muso02;
	ITEM scene;

	//DEFINIZIONE LUCI///////////////////////////////////////////////////////////////////////////

	set_background(0.675,0.855,0.953,TRUE);
	set_ambient_light(0.9,0.9,0.9,2.5);
	Luce01 = create_point_light(14.178,7.549,104.596,1,1,1,1.5,1000, "Luce01");
	Luce02 = create_warn_light(4.959,1.545,4.848,-0.244,-0.202,-0.948,1,1,1,1.5,11,0,58.0,0,0.0,0.0,0.0,0.0, "Luce02");

	//ATTRIBUTI//////////////////////////////////////////////////////////////////////////////////

	//ATTRIBUTO Legno

	legno = create_attribute("legno");
	set_color(legno,0.6,0.4,0.3,0.1,0.8);
	set_reflectivity(legno,0.1,100);

	// ATTRIBUTO Carta

	carta = create_attribute("carta");
	set_color(carta,0.63,0.64,0.60,0.05,0.22);
	set_reflectivity(carta,0.1,1);

	// ATTRIBUTO Metallo

	metallo = create_attribute("metallo");
	set_color(metallo,0.72,0.72,0.72,0.1,0.449);
	set_reflectivity(metallo,0.2,128);

	// ATTRIBUTO Parquet

	parquet = create_attribute("parquet");
	set_color(parquet,1,0.69,0.4,0.1,0.7);
	set_reflectivity(parquet,0.05,25);

	// ATTRIBUTO Plastica

	plastica = create_attribute("plastica");
	set_color(plastica,0.42,0.47,0.44,0.2,0.45);
	set_reflectivity(plastica,0.15,30);

	// ATTRIBUTO Intonaco

	intonaco = create_attribute("intonaco");
	set_color(intonaco,0.83,0.82,0.8,0.1,0.697);
	set_reflectivity(intonaco,0,12);

	// ATTRIBUTO Rosso

	rosso = create_attribute("rosso");
	set_color(rosso,0.68,0,0,0.1,0.3);
	set_reflectivity(rosso,0.07,30);

	// ATTRIBUTO Nero

	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.1,0.3);
	set_reflectivity(nero,0.04,30);

	// ATTRIBUTO NeroGomma

	nerogomma = create_attribute("nerogomma");
	set_color(nerogomma,0.22,0.22,0.22,0.03,0.036);
	set_reflectivity(nerogomma,0.03,30);

	// ATTRIBUTO Giallo

	giallo = create_attribute("giallo");
	set_color(giallo,0.84,0.65,0.43,0,1);
	set_reflectivity(giallo,0,2);

	// ATTRIBUTO Plastica2

	plastica2 = create_attribute("plastica2");
	set_color(plastica2,0.64,0.6,0.50,0.1,0.3);
	set_reflectivity(plastica2,0.15,30);

	// ATTRIBUTO Metallo2

	metallo2 = create_attribute("metallo2");
	set_color(metallo2,0.72,0.72,0.72,0.1,0.9);
	set_reflectivity(metallo2,0.5,128);

	// ATTRIBUTO Grigio

	grigio = create_attribute("grigio");
	set_color(grigio,0.20,0.24,0.20,0.24,0.20);
	set_reflectivity(grigio,0.15,30);

	// ATTRIBUTO Bianco

	bianco = create_attribute("bianco");
	set_color(bianco,1.0,1.0,1.0,0.0,1.0);
	set_reflectivity(bianco,0.0,2);

	// STANZA////////////////////////////////////////////////////////////////////////////////////

	parete_dx = read_nurbs("PianoVerticale0.db");
	parete_sx = read_nurbs("PianoVerticale1.db");
	pavimento = read_nurbs("PianoTerra.db");
	parete_post = read_nurbs("PianoVerticale2.db");
	quadro = read_nurbs("SupportoQuadro.db");
	superficie_quadro = read_nurbs("TelaQuadro.db");

	set_attribute(parete_dx, intonaco);
	set_attribute(parete_sx, intonaco);
	set_attribute(parete_post, intonaco);
	set_attribute(pavimento, intonaco);
	set_domain_texture(pavimento, intonaco, "Textures/444-v1.hr",0,1,0,1,1,0.2,0.3);
	set_attribute(quadro, bianco);
	set_attribute(superficie_quadro, bianco);
	set_domain_texture(superficie_quadro, intonaco, "Textures/AyrtonSenna.hr",0,1,0,1,0,0.3,0.4);

	stanza = create_list(parete_sx, "stanza");
	stanza = insert_in_list(stanza,parete_dx);
	stanza = insert_in_list(stanza,parete_post);
	stanza = insert_in_list(stanza,pavimento);
	stanza = insert_in_list(stanza,quadro);
	stanza = insert_in_list(stanza,superficie_quadro);


	//SCRIVANIA//////////////////////////////////////////////////////////////////////////////////
	
	piano_scrivania = read_nurbs("Tavolo0.db");
	gamba01 = read_nurbs("PiedeTavolo0.db");
	gamba02 = read_nurbs("PiedeTavolo1.db");
	gamba03 = read_nurbs("PiedeTavolo2.db");
	gamba04 = read_nurbs("PiedeTavolo3.db");

	set_attribute(piano_scrivania, legno);
	set_domain_texture(piano_scrivania, legno, "Textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba01, legno);
	set_domain_texture(gamba01, legno, "Textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba02, legno);
	set_domain_texture(gamba02, legno, "Textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba03, legno);
	set_domain_texture(gamba03, legno, "Textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba04, legno);
	set_domain_texture(gamba04, legno, "Textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);

	scrivania = create_list(piano_scrivania, "scrivania");
	scrivania = insert_in_list(scrivania,gamba01);
	scrivania = insert_in_list(scrivania,gamba02);
	scrivania = insert_in_list(scrivania,gamba03);
	scrivania = insert_in_list(scrivania,gamba04);

	
	// LAMPADA///////////////////////////////////////////////////////////////////////////////////

	lampada = read_obj("LampadaFinale.obj", "lampada");
	set_attribute(lampada,metallo);


	//PEDANA/////////////////////////////////////////////////////////////////////////////////////

	pedana = read_obj("Pedana.obj", "pedana");
	set_attribute(pedana, intonaco);

	
	//MACCHINA///////////////////////////////////////////////////////////////////////////////////

	//Ruote

	ruote = read_obj("RuoteFinali.obj","ruote");
	set_attribute(ruote,nerogomma);
	
	//Ala Anteriore

	alaAnteriore = read_obj("AlaAnterioreFinale.obj","alaAnteriore");
	set_attribute(alaAnteriore,nero);

	//Airscope

	airscope = read_obj("AirscopeFinale.obj","airscope");
	set_attribute(airscope,rosso);
	set_domain_texture(airscope, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);

	//Cassettone

	cassettone01 = read_nurbs("CassettoneBis.db");
	cassettone02 = read_nurbs("Cassettone.db");
	
	set_attribute(cassettone01,rosso);
	set_domain_texture(cassettone01, rosso, "Textures/Campionatore3.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(cassettone02,rosso);
	set_domain_texture(cassettone02, rosso, "Textures/ColCassettoneBis.hr",0,1,0,1,1,0.5,0.2);

	cassettone = create_list(cassettone01, "Cassettone");
	cassettone = insert_in_list(cassettone,cassettone02);

	//Motore 

	motore01 = read_nurbs("Motore.db");
	motore02 = read_nurbs("MotoreBis.db");
	motore03 = read_nurbs("ChiusuraMotore0.db");
	motore04 = read_nurbs("ChiusuraMotore1.db");

	set_attribute(motore01,rosso);
	set_domain_texture(motore01, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(motore02,rosso);
	set_domain_texture(motore02, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(motore03,nero);
	set_attribute(motore04,nero);

	motore = create_list(motore01, "motore");
	motore = insert_in_list(motore,motore02);
	motore = insert_in_list(motore,motore03);
	motore = insert_in_list(motore,motore04);

	//Muso

	muso01 = read_nurbs("Muso.db");
	muso02 = read_nurbs("MusoBis.db");

	set_attribute(muso01,rosso);
	set_domain_texture(muso01, rosso, "Textures/ColoreMuso.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(muso02,rosso);
	set_domain_texture(muso02, rosso, "Textures/ColoreMusoBis.hr",0,1,0,1,1,0.5,0.2);

	muso = create_list(muso01, "muso");
	muso = insert_in_list(muso,muso02);

	//Ala Posteriore

	supportoAla = read_obj("BarraAlettoneFinale.obj","supportoAla");
	set_attribute(supportoAla,nero);

	alaPost01 = read_nurbs("PianoAlaPost01.db");
	alaPost02 = read_nurbs("PianoAlaPost02.db");
	alaPost03 = read_nurbs("AlaPosterioreFinale.db");

	set_attribute(alaPost01,nero);
	set_domain_texture(alaPost01, nero, "Textures/ColAlaPost.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(alaPost02,nero);
	set_domain_texture(alaPost02, nero, "Textures/ColAlaPostBis.hr",0,1,0,1,1,0.5,0.2);
	set_attribute(alaPost03,nero);

	alaPosteriore = create_list(alaPost01, "alaPosteriore");
	alaPosteriore = insert_in_list(alaPosteriore, alaPost02);
	alaPosteriore = insert_in_list(alaPosteriore, alaPost03);

	//Cockpit

	cockpit = read_obj("CockpitFinale.obj","cockpit");
	set_attribute(cockpit,rosso);
	set_domain_texture(cockpit, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);

	//Retrotreno
	
	retrotreno = read_obj("RetrotrenoFinale.obj","retrotreno");
	set_attribute(retrotreno,nero);

	//Fondopiatto

	fondopiatto = read_obj("FondoPiattoFinale.obj","fondopiatto");
	set_attribute(fondopiatto,nero);

	//Piega Airscope

	piegaAirscope = read_obj("PiegaAirscopeFinale.obj","piegaAirscope");
	set_attribute(piegaAirscope,rosso);
	set_domain_texture(piegaAirscope, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);

	//Cerchioni

	cerchioni = read_obj("CerchioniFinali.obj","cerchioni");
	set_attribute(cerchioni,nerogomma);

	//Prese Aria

	preseAria = read_obj("PreseAriaFinali.obj","preseAria");
	set_attribute(preseAria,rosso);
	set_domain_texture(preseAria, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);

	//Sospensioni

	sospensioniAnt = read_obj("SospensioniAntFinali.obj","sospensioniAnt");
	set_attribute(sospensioniAnt,nero);

	sospensioniPos = read_obj("SospensioniPosFinali.obj","sospensioniPos");
	set_attribute(sospensioniPos,nero);

	//Musetto

	musetto = read_obj("MusettoFinale.obj","musetto");
	set_attribute(musetto, rosso);
	set_domain_texture(musetto, rosso, "Textures/ColoreMacchina.hr",0,1,0,1,1,0.5,0.2);

	// SCENA FINALE//////////////////////////////////////////////////////////////////////////////

	scene = create_list(scrivania, "scene");
	scene = insert_in_list(scene, lampada);
	scene = insert_in_list(scene, stanza);
	scene = insert_in_list(scene, pedana);
	scene = insert_in_list(scene, ruote);
	scene = insert_in_list(scene, alaAnteriore);
	scene = insert_in_list(scene, airscope);
	scene = insert_in_list(scene, cassettone);
	scene = insert_in_list(scene, muso);
	scene = insert_in_list(scene, motore);
	scene = insert_in_list(scene, cockpit);
	scene = insert_in_list(scene, retrotreno);
	scene = insert_in_list(scene, fondopiatto);
	scene = insert_in_list(scene, piegaAirscope);
	scene = insert_in_list(scene, cerchioni);
	scene = insert_in_list(scene, preseAria);
	scene = insert_in_list(scene, sospensioniAnt);
	scene = insert_in_list(scene, sospensioniPos);
	scene = insert_in_list(scene, supportoAla);
	scene = insert_in_list(scene, alaPosteriore);
	scene = insert_in_list(scene, musetto);
	save_scene("car.md","scena_finale",scene);
	return(0);	

}
